require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

// #ITP_FORM_BIZPOP_WISH_LIST_ITEM_LIST 위시리스트 마스터 선택

function itp_fn_BIZPOP_WISH_LIST_ITEM(parentPopFn, args, returnType) {
	const THIS_GIRD_ID = '#ITP_BIZPOP_WISH_LIST_ITEM_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_WISH_LIST_ITEM_jqGridPager';
	// 그리드 조회
	const grid=$(THIS_GIRD_ID);
	grid.jqGrid({
		colModel: [ 
			{
				index: 'BRAND_ID', name: 'brandId',
				label: ITP_MSG_LOCALE.label.brandId,
				width: 0, fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'BRAND_UNIT_UNQ_NO', name: 'brandUnitUnqNo',
				label: '브랜드단가고유번호', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'UNIT_GUBUN', name: 'unitGubun',
				label: '단가구분', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'STORE_UNIT_UNQ_NO', name: 'storeUnitUnqNo',
				label: '매장단가고유번호', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},   
			{
				index: 'ITEM_NO', name: 'itemId',
				label: '품목번호',
				width: 120, fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_CLASS_NM', name: 'itemNm',
				label: '품목명',
				width: 200, fixed: false, align: 'left',
				sortable: false, hidden: false, classes: 'ui-ellipsis'
			},
			{
				index: 'UNIT', name: 'unit',
				label: '단위', 
				width: 80, fixed: false, align: 'center'
			},  			
			{
				index: 'UNIT', name: 'unitAmt',
				label: '단가', 
				width: 120, fixed: false, align: 'right',
				sortable: false, hidden: false,
				formatter: 'integer', formatoptions: {thousandsSeparator: ','}
			}
		],
		multiselect: true,
		rownumbers: false, 
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	

	const search=function() { 
		if(!wishListMgntNo) return itp_fn_modal_alert_ajax("조회할 위시리스트를 선택하세요");
		ajaxCall('/api/pomng/select-wishlist-item', {brandId, storeId, wishListMgntNo}, function(result) { 
			grid.jqGrid('clearGridData');
			for(var cur of result.selectRows ) {
				grid.jqGrid('addRowData', cur.itemId, cur, 'last');
			}
			gridStatus(THIS_GIRD_ID, 'BIZPOP_WISH_LIST_ITEM', '위시리스트를 선택하세요');			
		}); 
	};
	 
	var wishListMgntArr=[], currentNode=null;
	var wishListMgntNo=null; 
	const combo=$('#ITP_FORM_BIZPOP_WISH_LIST_ITEM_LIST');	
	const brandId=fn_make_user_info.get('brandId'), storeId=fn_make_user_info.get('storeId');
	const wishListFind= function() {
		console.log("find ", wishListMgntArr, wishListMgntNo )
		for(var cur of wishListMgntArr) if(cur.wishListMgntNo==wishListMgntNo) return cur;
		return null;
	};
	const wishListMgntCall= function() {
		/* 위시리스트 추가/수정 API 처리 */
		ajaxCall('/api/pomng/select-wishlist', {brandId, storeId}, function(result) {
			combo.data('changeCheck', true);
			combo.children('option:not(:first)').remove();
			wishListMgntArr=result.selectRows;
			var def='';
			for(var cur of wishListMgntArr ) {
				if(!def) def=cur.wishListMgntNo;
				$('<option/>', { 'value': cur.wishListMgntNo, 'text': cur.wishListNm }).appendTo(combo);
			}
			combo.data('changeCheck', false);
			if(def) combo.val(def);
			combo.trigger('change');
			
		}, 'GET'); 
	}; 
	// 위시리스트 콤보 변경처리
	combo.on('change', function() {
		if(combo.data('changeCheck')) return;
		wishListMgntNo=combo.val();
		currentNode=wishListFind();
		if(wishListMgntNo) search();
	});
	// 위시리스트 콤보 조회
	wishListMgntCall();	 
	/*
	$('#ITP_FORM_BIZPOP_WISH_LIST_ITEM_BRAND_ID').val(fn_make_user_info.get('brandId'));
	$('#ITP_FORM_BIZPOP_WISH_LIST_ITEM_STORE_ID').val(fn_make_user_info.get('storeId'));
	$('#ITP_FORM_BIZPOP_WISH_LIST_ITEM_WHS_DVSN').val(args.whsDvsn);
	*/
	
	$('#ITP_BIZPOP_WISH_LIST_ITEM').one('shown.bs.modal', function(e) {
		grid.setGridWidth(642, true); 
		const cols =grid.getGridParam('colModel'), last=cols.length-1, col=cols[last];
		$(THIS_GIRD_ID+'_list table').find('td:eq('+last+')').each(function(){$(this).css('width',col.width-2);});  
		 
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_WISH_LIST_ITEM').remove();
	}).modal('show');

	$('#ITP_BIZPOP_WISH_LIST_ITEM_BTN_SEARCH').on('click', function() {
		search();
	});
	
	$('#ITP_BIZPOP_WISH_LIST_ITEM_BTN_SELECT').on('click', function() {	
		const rowKey = grid.getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }
		const selectedIds = grid.getGridParam('selarrrow'), result=[]; 
		if(Array.isArray(selectedIds) ) {
			for (var i=selectedIds.length-1; i>=0; i--) {
				const cur=grid.jqGrid('getRowData', selectedIds[i]);
				result.push(cur );
			} 
			parentPopFn(result);
			$('#ITP_BIZPOP_WISH_LIST_ITEM').modal('hide'); // 팝업닫기 
		}
	}); 
	
};
