require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let API_POP_LACKSTCK_GRID_LIST = '/api/item/pop-lackstck-grid-list';
let WHS_MNG_DETAIL_GRID_LIST = '/api/whs/mng/detail-grid-list';
let WHS_MNG_LOCATION_GRID_LIST = '/api/whs/mng/location-grid-list';

function itp_fn_BIZPOP_SAFE_STCK_ITEM(parentPopFn, args, returnType) {
	console.log(args);
	let itp_BIZPOP_SAFE_STCK_ITEM_param = {};
	let itp_BIZPOP_SAFE_STCK_ITEM_search = false;
	let LOGIN_AUTH_TYPE_CD = fn_make_user_info.get('authTpCd');
	let firstWhsId;

	const THIS_FORM_ID = '#ITP_FORM_BIZPOP_SAFE_STCK_ITEM';
	const THIS_GIRD_ID = '#ITP_BIZPOP_SAFE_STCK_ITEM_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_SAFE_STCK_ITEM_jqGridPager';

	$('#ITP_FORM_BIZPOP_SAFE_STCK_ITEM_BRAND_ID').val(fn_make_user_info.get('brandId'));
	$('#ITP_FORM_BIZPOP_SAFE_STCK_ITEM_STORE_ID').val(fn_make_user_info.get('storeId'));

	// 공통코드 표시
	$('select').each(function() {
		if($(this).data('select-code')) {
			fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
		}
	});

	$('#ITP_BIZPOP_SAFE_STCK_ITEM').one('shown.bs.modal', function(e) {
		itp_fn_jqgrid_resize(THIS_GIRD_ID, '#ITP_BIZPOP_SAFE_STCK_ITEM_jqGrid_list', '');
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_SAFE_STCK_ITEM').remove();
	}).modal('show');

	$('#ITP_BIZPOP_SAFE_STCK_ITEM_BTN_SEARCH').on('click', function() {
		itp_BIZPOP_SAFE_STCK_ITEM_search = true;
		let param = $(THIS_FORM_ID).serializeObject();
		param.gridSize = 10;
		param.gridPage = $.jgrid.defaults.page;
		//console.log(param);
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
	});
	
	$('#ITP_BIZPOP_SAFE_STCK_ITEM_BTN_SELECT').on('click', function() {		
		
		const rowKey = $(THIS_GIRD_ID).getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }

		var list = [];
	    var selectedIds = $(THIS_GIRD_ID).getGridParam('selarrrow');

		if(selectedIds.length > 1) { // 1개만 선택
			// itp_fn_modal_alert('1명을 선택해주세요.');
			// return;
		}
		
	    for (var i=selectedIds.length-1; i>=0; i--) {
			list.push($(THIS_GIRD_ID).jqGrid('getRowData', selectedIds[i]));	
		}
		parentPopFn(list);
		$('#ITP_BIZPOP_SAFE_STCK_ITEM').modal('hide'); // 팝업닫기
	});

	$('#ITP_BIZPOP_SAFE_STCK_ITEM_jqGridEmpty').on('click', function() {
		itp_fn_BIZPOP_SAFE_STCK_ITEM_empty.back();
		itp_BIZPOP_SAFE_STCK_ITEM_param.gridSize = 10;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(itp_BIZPOP_SAFE_STCK_ITEM_param)}).trigger('reloadGrid');
	});

	var itp_fn_BIZPOP_SAFE_STCK_ITEM_empty = {
		push: function() {
			let param = $(THIS_FORM_ID).serializeObject();
			itp_BIZPOP_SAFE_STCK_ITEM_param = param;
		},
		back: function() {
			$(THIS_FORM_ID + '_BRAND_ID').val(itp_BIZPOP_SAFE_STCK_ITEM_param.sbrandId);
			$(THIS_FORM_ID + '_STROE_ID').val(itp_BIZPOP_SAFE_STCK_ITEM_param.sstoreId);
		}
	};

	let fnWhsList = function(fnCall) {
		const brandIdVal = $('#ITP_FORM_BIZPOP_SAFE_STCK_ITEM_BRAND_ID').val();	
		const storeIdVal = $('#ITP_FORM_BIZPOP_SAFE_STCK_ITEM_STORE_ID').val();
		const whsDvsnVal = LOGIN_AUTH_TYPE_CD == '50' ? 'W02' : 'W01'; // 본사/매장 구분
		
		const param = {swhsDvsn: whsDvsnVal, sbrandId: brandIdVal, sstoreId: storeIdVal, pagingYn: false};
		
		fn_ajax_call(WHS_MNG_DETAIL_GRID_LIST, JSON.stringify(param), function(result) {
			firstWhsId = result.gridRows[0].whsId;
			fn_make_select_whs(result.gridRows, 'ITP_FORM_BIZPOP_STORE_WHS_NM');				
			if (fnCall !== undefined || typeof fnCall !== 'undefined') fnCall();						
		}, 'POST');
	}
	fnWhsList();
	
	itp_fn_BIZPOP_SAFE_STCK_ITEM_empty.push();
	let param = $('#ITP_FORM_BIZPOP_SAFE_STCK_ITEM').serializeObject();
	param.gridSize = 10;
	param.swhsId = firstWhsId;
	//console.log(JSON.stringify(param));

	$(THIS_GIRD_ID).jqGrid({
		colModel: [
			{
				index: 'WHS_NM', name: 'whsNm',
				label: '창고명', //
				width: '13', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_ID', name: 'itemId',
				label: '품목ID', //
				width: '13', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_NM', name: 'itemNm',
				label: '품목명', //
				width: '8', fixed: false, align: 'left',
				sortable: false, hidden: false, classes: 'ui-ellipsis'
			},
			{
				index: 'UNIT', name: 'unit',
				label: '단위', //
				width: '4', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PODR_PSSBL_DVSN_NM', name: 'podrPssblDvsnNm',
				label: '발주가능여부', //
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PODR_PSSBL_DVSN', name: 'podrPssblDvsn',
				label: '발주가능여부', //
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'UNIT_AMT', name: 'unitAmt',
				label: '단가', //
				width: '10', fixed: false, align: 'right',
				sortable: false, hidden: false,
				formatter: 'integer', formatoptions: {thousandsSeparator: ','}
			},
			{
				index: '', name: 'stckQty',
				label: '현수량', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_REQ_QTY', name: 'pchReqQty',
				label: '요청수량', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: '', name: 'curQty',
				label: '안전재고수량', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: '', name: 'prpStckQty',
				label: '안전재고 기준수량', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: '', name: 'brandUnitUnqNo',
				label: '브랜드단가번호', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: '', name: 'storeUnitUnqNo',
				label: '매장단가번호', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: '', name: 'unitGubun',
				label: '브랜드매장단가구분', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			}    
			
			
		],
		loadBeforeSend: function(jqXHR) {
		    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
		},
		postData: JSON.stringify(param),
		url: DOMAIN + API_POP_LACKSTCK_GRID_LIST,
		pager: THIS_GIRD_PAGER,
		multiselect: true,
		multiboxonly: true,
		rownumbers: false,
		loadComplete: function(data) {
			//console.log(data);
			itp_fn_grid_load_complete(data, THIS_GIRD_ID, true, undefined, 'BIZPOP_SAFE_STCK_ITEM', itp_BIZPOP_SAFE_STCK_ITEM_search, itp_fn_BIZPOP_SAFE_STCK_ITEM_empty, true, data.gridRecords, false);
	    },
	    loadError: function(jqXHR, textStatus, errorThrown) {
	    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
	    },
	    onPaging: function(action) {
	    	itp_fn_grid_paging(THIS_GIRD_ID, action, param);
	    }
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);	
};
